/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 * explore.c -- display systems/worlds explored 
 *  (this command written by Dan Corrin, dan@geomech.engrg.uwo.ca)
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
extern float compatibility(); /* gvc modification */
int explore_racedata;

colonies(Playernum,APcount, argn, args)
int Playernum;
int APcount, argn;
char *args[];
{
int star,i,j;
planettype *pl;
int inhab = 0;
int stardata,pdata;
char str[200];

 Num_races = Numraces();

free(Race);
openracedata(&explore_racedata);
getrace(explore_racedata, &Race, Playernum);
close_file(explore_racedata);

 openstardata(&stardata);
 getsdata(stardata,&Sdata);
 openpdata(&pdata);
 sprintf(buf,"             ========== Colonization Report ==========\n\n");
	notify(Playernum, buf); 
sprintf(buf,"       Planet        res  des fuel tox sects tech  mob       Type       Aliens\n");
	notify(Playernum, buf);
 for (star=0; star<Sdata.numstars; star++) {
    getstar(stardata, &(Stars[star]), star);
    if (isset(Stars[star]->explored,Playernum)) {
        for (i=0; i<Stars[star]->numplanets; i++) {
           getplanet(pdata,&pl,Stars[star]->planetpos[i]);

           if (pl->info[Playernum-1].explored 
	       && pl->info[Playernum-1].numsectsowned)  {
                inhab = 0;

		sprintf(str,"%s/%s%s", Stars[star]->name,
			Stars[star]->pnames[i],
			(pl->info[Playernum-1].autorep ? "*" : ""));

		sprintf(buf,"%19s%5d%5d%5d %3d%% %4d %3d  %2d(%2d)",
		       str,pl->info[Playernum-1].resource,
		       pl->info[Playernum-1].destruct,
		       pl->info[Playernum-1].fuel,pl->conditions[TOXIC],
		       pl->info[Playernum-1].numsectsowned,
		       pl->info[Playernum-1].tech_invest,
		       pl->info[Playernum-1].comread,
		       pl->info[Playernum-1].mob_set);
			notify(Playernum, buf);

                switch(pl->type) {
                        case TYPE_EARTH:        sprintf(buf," Class M "); break;
                        case TYPE_ASTEROID:     sprintf(buf," Asteroid"); break;
                        case TYPE_AIRLESS:      sprintf(buf," Airless "); break;
                        case TYPE_ICEBALL:      sprintf(buf," Iceball "); break;
                        case TYPE_GASGIANT:     sprintf(buf," Jovian  "); break;
			case TYPE_WATER:        sprintf(buf," Water   "); break;
			default: 
				sprintf(buf, "Unknown");
				break;
                }
		notify(Playernum, buf);
                sprintf(buf,"%3.0f%% ",compatibility(pl,Race));
		notify(Playernum, buf);
                for (j=1; j<=Num_races; j++) 
			if (j!=Playernum && pl->info[j-1].numsectsowned>0)
				{
				sprintf(buf,"%d ",j);
					notify(Playernum, buf);
				}
	notify(Playernum, "\n");
           } 
	   free(pl);
        }
    }
 }
 close_file(stardata);
 close_file(pdata);
}


exploration(Playernum,APcount, argn,args)
int Playernum;
int APcount, argn;
char args[MAXARGS][COMMANDSIZE];
{
int star,starq,i,j;
planettype *pl;
placetype where;
int inhab = 0;
int stardata,pdata;

 Num_races = Numraces();

	starq = 0;

if(argn==2) {
	where = Getplace(Playernum,args[1],0);
	if(where.err) {
		sprintf(buf, "explore: bad scope.\n");
			notify(Playernum, buf);
		return;
		}
	starq = where.snum;
	}

free(Race);
openracedata(&explore_racedata);
getrace(explore_racedata, &Race, Playernum);
close_file(explore_racedata);

 openstardata(&stardata);
 getsdata(stardata,&Sdata);
 openpdata(&pdata);
 sprintf(buf,"         ========== Exploration Report ==========\n");
			notify(Playernum, buf);
 sprintf(buf," Global action points : [%2d]\n",Sdata.AP[Playernum-1]);
 			notify(Playernum, buf);
sprintf(buf," Star  (stability)[AP]   #  Planet [Attributes] Type (Compatibility)\n");
			notify(Playernum, buf);
 for (star=0; star<Sdata.numstars; star++)
 	if((starq ==0) || (starq  && starq == star)) {
    getstar(stardata, &(Stars[star]), star);
    if (isset(Stars[star]->explored,Playernum)) {
        for (i=0; i<Stars[star]->numplanets; i++) {
           getplanet(pdata,&pl,Stars[star]->planetpos[i]);
           if (i == 0)
                if (Race->tech >= TECH_SEE_STABILITY){
                    sprintf(buf,"\n%13s (%2d)[%2d]",Stars[star]->name,Stars[star]->stability,Stars[star]->AP[Playernum-1]);
			notify(Playernum, buf);
	} else {
                    sprintf(buf,"\n%13s (??)[%2d]",Stars[star]->name,Stars[star]->stability,Stars[star]->AP[Playernum-1]);
		notify(Playernum, buf);
	} else {
                sprintf(buf,"\t\t      ");
		notify(Playernum, buf);
		}
           sprintf(buf,"  #%d. %-15s [ ",i+1,Stars[star]->pnames[i]);
		notify(Playernum, buf);
           if (pl->info[Playernum-1].explored)  {
                sprintf(buf,"Expl ");
		notify(Playernum, buf);
                if (pl->info[Playernum-1].autorep) {
		sprintf(buf,"Report ");
		notify(Playernum, buf);
			}
                if (pl->info[Playernum-1].numsectsowned) {
		sprintf(buf,"Inhab ");
		notify(Playernum, buf);
			}
		if (pl->slaved_to) {
		sprintf(buf,"SLAVED ");
		notify(Playernum, buf);
			}
                inhab = 0;
                for (j=1; j<=Num_races; j++) 
			if (j!=Playernum && pl->info[j-1].numsectsowned) {
				sprintf(buf,"%d ",j);
				notify(Playernum, buf);
				}
                if (pl->conditions[TOXIC] > 70) {
				sprintf(buf,"TOXIC ");
				notify(Playernum, buf);
				}
                switch(pl->type) {
                        case TYPE_EARTH:        sprintf(buf,"] Class M"); break;
                        case TYPE_ASTEROID:     sprintf(buf,"] Asteroid"); break;
                        case TYPE_AIRLESS:      sprintf(buf,"] Airless"); break;
                        case TYPE_ICEBALL:      sprintf(buf,"] Iceball"); break;
                        case TYPE_GASGIANT:     sprintf(buf,"] Jovian"); break;
			case TYPE_WATER:        sprintf(buf,"] Water"); break;
			default:				sprintf(buf,"] Unknown");break;
                }
			notify(Playernum, buf);
                sprintf(buf," (%.2f%%)\n",compatibility(pl,Race));
			notify(Playernum, buf);
           } else {
		sprintf(buf,"No Data ]\n");
		notify(Playernum, buf);
		}
	   free(pl);
        }
    }
 }
 close_file(stardata);
 close_file(pdata);
}

