/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * fire.c -- fire at ship or planet from ship or planet
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
#include <signal.h>

int fire_fromshdata,fire_toshdata,
    fire_frompdata,fire_topdata,fire_sectdata;
char temp[128];

fire(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
placetype from,to,to2;
planettype *fpl,*tpl,*tpl2;
sectortype *sect;
shiptype *ship;
int dam=0,dam2=0,dam3=0,condition, ok,
	strength,oldstrength,maxstrength,tostrength,to2strength,
    i,from_firex= -1,from_firey= -1,firex= -1,firey= -1,Numplayersretaliate=0;
int sh;
float dist,tech;
char string[PLACENAMESIZE],buf[200];
char shoot_msg[1000], retal_msg[1000];
boolean sameplanet = 0, fromplanetmod=0,toplanetmod=0;
int mask;

fire_fromshdata = fire_toshdata = fire_frompdata = fire_topdata = 
		fire_sectdata = NEUTRAL_FD;

	Num_races = Numraces();

	/* for telegramming and retaliating */
 bzero( (char *)Nuked, sizeof(Nuked) );

	/***** get place we are firing from *****/

sscanf(args[1],"%35s",string);

 from = Getplace(Playernum,string,0);

 if (from.err && from.level!=LEVEL_SHIP) { 
	sprintf(buf,"usage: fire\n");
		notify(Playernum, buf);
	return; 
 }


 if (from.level == LEVEL_UNIV || from.level == LEVEL_STAR) {

    sprintf(buf,"You can't shoot from there.\n");
	notify(Playernum, buf);
	return;
 } else if (from.level == LEVEL_SHIP) {

    if (from.err || from.shipptr->owner != Playernum) {
	DontOwnErr(Playernum, from.shipno);
	return;
    }

     free(from.shipptr);		
     openshdata(&fire_fromshdata);
     (void)getship(fire_fromshdata,&(from.shipptr),from.shipno);
    close_file(fire_fromshdata);
   if (testship(Playernum,from.shipptr, from.shipno)) {
	return;
	}
     /* check for APs */
    if (from.shipptr->whatorbits==LEVEL_UNIV) {
	if (!enufAP(Playernum,Sdata.AP[Playernum-1], APcount) )
		return;
    } else
	if (!enufAP(Playernum,Stars[from.shipptr->storbits]->AP[Playernum-1], APcount) ) {
			return;
		}

     /* get planet we're landed on to calculate x,y pos */
    if (from.shipptr->is_docked && from.shipptr->whatdest==LEVEL_PLAN) {
	    openpdata(&fire_frompdata);
	    getplanet(fire_frompdata,&fpl,Stars[from.snum]->planetpos[from.pnum]);
	    close_file(fire_frompdata);
    }

 } else if (from.level==LEVEL_PLAN) {

   openpdata(&fire_frompdata);
    getplanet(fire_frompdata,&fpl,Stars[from.snum]->planetpos[from.pnum]);
close_file(fire_frompdata);
   if (!enufAP(Playernum,Stars[from.snum]->AP[Playernum-1], APcount) ) { 
	return;
	}

   if (fpl->info[Playernum-1].destruct == 0) {
	sprintf(buf,"No weapons available.\n");
		notify(Playernum, buf);
	return;
   }
   if (fpl->slaved_to>0 && fpl->slaved_to!=Playernum) {
	sprintf(buf,"That planet is enslaved!\n");
		notify(Playernum, buf);
	return;
   }

 } else {
	sprintf(buf,"You can't shoot from there.\n");
		notify(Playernum, buf);
	return;
 }


  /******* get target *******/

 sscanf(args[2],"%35s",string); 

  to = Getplace(Playernum,string,1);
 if (to.err) {
	return;
	}

 if (to.level==LEVEL_SHIP) {
	if (from.level==LEVEL_SHIP) {
		if (from.shipno == to.shipno) {
			sprintf(buf,"You can't do that.\n");
				notify(Playernum, buf);
			return;
		} 

	} else if (from.level==LEVEL_PLAN &&
			   !((to.shipptr->whatorbits == LEVEL_PLAN) &&
			     (to.shipptr->pnumorbits == from.pnum))) { 
		  /* planets can only fire at orbiting ships*/
		        sprintf(buf,"Planets can only fire at ships in orbit.\n");
				notify(Playernum, buf);
			return;
		      }

		/* get ship again */
	free(to.shipptr);
	openshdata(&fire_toshdata);
	(void)getship(fire_toshdata, &(to.shipptr), to.shipno);
	close_file(fire_toshdata);
	if (!to.shipptr->is_alive) {
		sprintf(buf,"that ship has already been destroyed.\n");
		notify(Playernum, buf);
		return;
	}

/* save defense attack strength for retaliation */
  tostrength = MIN(to.shipptr->destruct,   
		Guns(to.shipptr) *
		   .0001*(100-to.shipptr->rad)*(100-to.shipptr->damage));

	if ((to.shipptr->is_docked && to.shipptr->whatdest==LEVEL_PLAN)
		|| to.shipptr->whatorbits==LEVEL_PLAN) {
		openpdata(&fire_topdata);
		getplanet(fire_topdata,&tpl,Stars[to.snum]->planetpos[to.pnum]);
		close_file(fire_topdata);
	}

 } else if (to.level==LEVEL_PLAN) {

	if (from.level==LEVEL_PLAN) {
		if (from.snum == to.snum && from.pnum==to.pnum) {
	        	/* same planet as firing one */
                   /* disable the firing from planet to planet */
	   	   sprintf(buf,"You cannot fire from a planet to a planet !\n");
			notify(Playernum, buf);
		   sameplanet = 1;
		   tpl = fpl;
		return;
		}
	}

	if (!sameplanet) {
		openpdata(&fire_topdata);
		getplanet(fire_topdata,&tpl,Stars[to.snum]->planetpos[to.pnum]);
		close(fire_topdata);
	    }
 } else {
	notify(Playernum, "You can't shoot at that.\n");
	return;
 }



  maxstrength = (from.level==LEVEL_SHIP) ? 
		MIN(from.shipptr->destruct,   
			Guns(from.shipptr) *
		    .0001 * (100-from.shipptr->rad)*(100-from.shipptr->damage))
		  : MIN(fpl->info[Playernum-1].destruct, PLAN_FIRE_LIM);

sscanf(args[3],"%d",&strength);

 if (strength>maxstrength) {
	strength = maxstrength;
	sprintf(buf,"guns set to %d\n",strength);
		notify(Playernum, buf);
 }
 
 if (strength<=0) {
   	sprintf(buf,"no attack.\n");
		notify(Playernum, buf);
	return;
 }

     /* get a sector the enemy place can retaliate to. */

	if(from.level==LEVEL_PLAN) {

	sscanf(args[4],"%d,%d",&from_firex,&from_firey);

	if((from_firex < 0) || (from_firey < 0) || (from_firex > fpl->Maxx) || (from_firey > fpl->Maxy)) {
		sprintf(buf,"Illegal coordinates.\n");
			notify(Playernum, buf);
			return;
	} else {
	opensectdata(&fire_sectdata);
	getsector(fire_sectdata, &sect, fpl->sectormappos+(from_firey*fpl->Maxx+from_firex)*sizeof(sectortype));
	close_file(fire_sectdata);
	}

      if (sect->owner!=Playernum) {	/* has to be yours */
	   sprintf(buf,"You don't own that sector.\n");
		notify(Playernum, buf);
		return;
		}
    free(sect);
		} else if(to.level==LEVEL_PLAN) {
	sscanf(args[4],"%d,%d",&firex,&firey);

	if((firex < 0) || (firey < 0) || (firex > tpl->Maxx) || (firey > tpl->Maxy)) {
		sprintf(buf,"Illegal coordinates.\n");
			notify(Playernum, buf);
			return;
		}
/* check to see if there are any planetary defense networks on the planet */
ok = 1;
	sh = tpl->ships;
	openshdata(&fire_toshdata);
	while(sh && ok) {
        getship(fire_toshdata, &ship, sh);
	ok = !(ship->is_alive && ship->type==OTYPE_PLANDEF
	       && ship->owner != Playernum);
	sh = ship->nextship;
    }
	close_file(fire_toshdata);
if(!ok) {
notify(Playernum, "Target has planetary defense networks.\nThese have to be eliminated before you can attack sectors.\n");    
return;
}

    }

tech = 0.0;
if(from.level == LEVEL_SHIP)
		tech = from.shipptr->tech;
else if (from.level == LEVEL_PLAN)
		tech = 100.0;	

	/* block kill signals to foil cheaters */

 dam = shoot(Playernum, from, &to, Playernum, fpl, tpl, firex, firey, strength,
	     &dist, tech, shoot_msg,1 );	/*1==get smap*/


 if (dam < 0) {
	sprintf(buf,"Target out of range  %.2f!\n", SYSTEMSIZE);
		notify(Playernum, buf);
	return;
 } 

 sprintf(telegram_buf," BULLETIN from %s\n\n",Dispplace(Playernum, &to));

if(from.level==LEVEL_SHIP)
	sprintf(buf,"%s #%u %s [owner %u] ",Shipnames[from.shipptr->type],
			from.shipno,from.shipptr->name,from.shipptr->owner);
else if(from.level==LEVEL_PLAN)
	sprintf(buf,"%s ", Dispplace(Playernum, &from));

sprintf(temp, "%s", buf);

	str_cat(telegram_buf, buf);
	

 if (to.level==LEVEL_SHIP)
    sprintf(buf,"fired on %s #%u %s [owner %u] @ %s;\n", Shipnames[to.shipptr->type],
			to.shipno, to.shipptr->name, to.shipptr->owner,
			prin_ship_orbits(to.shipptr));
 else
    sprintf(buf,"fired on %s\n",Dispplace(Playernum, &to));

/* notify all players that inhabit this system of the attack */
    str_cat(temp, buf);
    str_cat(telegram_buf, buf);

 for (i=1; i<=Num_races; i++)
    if (Nuked[i-1] && i!=Playernum) {
	if(!notify(i, telegram_buf))
		push_message(TELEG_PLAYER_AUTO, i, telegram_buf);
    } else if (i!=Playernum && isset(Stars[Dir[Playernum-1].snum]->inhabited, i))
	notify(i, temp);

  sprintf(buf,"BOOM!!\n%s\n", shoot_msg);
	notify(Playernum, buf);

	str_cat(telegram_buf, buf);

 for (i=1; i<=Num_races; i++)
    if (Nuked[i-1] && i!=Playernum) {
	if(!notify(i, telegram_buf))
	    push_message(TELEG_PLAYER_AUTO, i, telegram_buf);
	}

 if (from.level==LEVEL_SHIP) {
	from.shipptr->destruct -= strength;
	from.shipptr->mass -= strength*MASS_DESTRUCT;
 } else if (from.level==LEVEL_PLAN) 
	fpl->info[Playernum-1].destruct -= strength;


/* defending player retaliates if he can */
	strength = 0;
 if ( to.level==LEVEL_SHIP && dam && to.shipptr->active
		&& to.shipptr->protect.self) {
	strength = tostrength;
	to.shipptr->destruct -= strength;
	to.shipptr->mass -= strength*MASS_DESTRUCT;

 } else if (to.level==LEVEL_PLAN) {	
/* all players owning planet retal. do not retaliate at long distances
	since it is 'unrealistic' and easy to drain defences */

 int strength2;
 int fstrength;
 
 fstrength = strength;

 strength = 0;
 
  	for (i=1; i<= Num_races; i++)
	   if (i!=Playernum && tpl->info[i-1].numsectsowned &&
		!(tpl->slaved_to>0 && tpl->slaved_to!=i) ) {

              /* add planet defense strength */

	     strength2 = tpl->info[i-1].destruct;
	        if(strength2 > PLAN_FIRE_LIM)
		  strength2 = PLAN_FIRE_LIM;

	     tpl->info[i-1].destruct -= strength2;

             strength += strength2;
	     Numplayersretaliate++;
	     if(strength2)
	       {
  sprintf(telegram_buf," BULLETIN from %s\n\n",Dispplace(Playernum, &to));
 
  sprintf(buf,"Planet returns fire with %d guns\n\n", strength2);
		notify(Playernum, buf);
		str_cat(telegram_buf, buf);
	       }
	   }
}
	dam2=0;

if (strength) {
   	sprintf(buf,"%s retaliates with %s%d guns!!\n", Dispplace(Playernum, &to), 
		Numplayersretaliate>1 ? "a total of " : "", strength);
		notify(Playernum, buf);
   	sprintf(buf,"%s retaliates with %s%d guns!!\n", Dispplace(Playernum, &to), 
		Numplayersretaliate>1 ? "a total of " : "", strength);
	str_cat(telegram_buf, buf);
 } else {
   sprintf(buf,"%s %s can not retaliate.\n",Dispplace(Playernum, &to),
	(to.level==LEVEL_PLAN) ? (tpl->slaved_to ? "is enslaved and " : "") : "");
	notify(Playernum, buf);
	str_cat(telegram_buf, buf); 
}


 	if(strength)
	{
		tech = 0.0;
		if(to.level == LEVEL_SHIP)
			tech = to.shipptr->tech;
		else if (to.level == LEVEL_PLAN)
			tech = 100.0;	


		dam2 = shoot(Playernum, to,&from, 
		     (to.level==LEVEL_SHIP ? to.shipptr->owner : 1),
		     tpl,fpl,from_firex,from_firey,strength,
		     &dist, tech,retal_msg, 1);

                if(dam2) {
                  sprintf(buf,"BOOM!!\n%s\n", retal_msg);
			notify(Playernum, buf);
		str_cat(telegram_buf, buf);
		}

 for (i=1; i<=Num_races; i++)
    if (Nuked[i-1] && i!=Playernum)
	if(!notify(i, telegram_buf))
	    push_message(TELEG_PLAYER_AUTO, i, telegram_buf);

	}


/* protecting ships retaliate individually, only if damage was inflicted */
		if( from.level==LEVEL_SHIP && dam)
			{

	sh = 0;
		if(to.level==LEVEL_SHIP) {
	if(to.shipptr->whatorbits==LEVEL_STAR) /* star level ships */
		sh = Stars[to.shipptr->storbits]->ships;
	if(to.shipptr->whatorbits==LEVEL_PLAN) /* planet level ships */
		{
	    openpdata(&fire_frompdata);
	    getplanet(fire_frompdata,&tpl,Stars[to.snum]->planetpos[to.pnum]);
	    close_file(fire_frompdata);
		sh = tpl->ships;
		}
	} else if(to.level==LEVEL_PLAN) {
		sh = tpl->ships;
					}

	while (sh && from.shipptr->is_alive) 
			{
	
	sprintf(string,"#%d",sh);

	 to2 = Getplace(Playernum,string,1);

	if(sh != from.shipno && sh != to.shipno)
	{

	condition = 0;
	if(to.level==LEVEL_SHIP)
		condition = (to2.shipptr->is_alive && to2.shipptr->active
				&& to2.shipptr->protect.on
				&& (to2.shipptr->protect.ship == to.shipno)) ;
	 else if (to.level==LEVEL_PLAN)
		condition = (to2.shipptr->is_alive && to2.shipptr->active
				&& to2.shipptr->protect.planet
				&& (from.shipptr->owner != to2.shipptr->owner));
				
	if(condition) {
  to2strength = MIN(to2.shipptr->destruct,   
			Guns(to2.shipptr) *
		   .0001 * (100-to2.shipptr->damage) * (100-to2.shipptr->rad));
	to2.shipptr->destruct -= to2strength;
	to2.shipptr->mass -= strength*MASS_DESTRUCT;

if (to2strength) {

 sprintf(telegram_buf," BULLETIN from %s\n\n",Dispplace(Playernum, &to2));

   sprintf(buf,"%s retaliates with  %s%d guns!!\n", Dispplace(Playernum, &to2), 
		Numplayersretaliate>1 ? "a total of " : "", to2strength);
	notify(Playernum, buf);
	str_cat(telegram_buf, buf);

	tech = to2.shipptr->tech;

	dam3 = shoot(Playernum, to2,&from,to2.shipptr->owner,tpl,fpl,from_firex,from_firey,to2strength, 
		   &dist, tech,retal_msg, 1);
		if(dam3) {
		sprintf(buf,"BOOM!!\n%s\n", retal_msg);
		notify(Playernum, buf);
		str_cat(telegram_buf, buf);
		}
  if(!notify(to2.shipptr->owner, telegram_buf))
      push_message(TELEG_PLAYER_AUTO, to2.shipptr->owner, telegram_buf);

	}
  
openshdata(&fire_toshdata);
  putship(fire_toshdata,to2.shipptr,to2.shipno); 
  close_file(fire_toshdata);
}

		}
		sh = to2.shipptr->nextship;

			}
	}


/* end of fire/retaliation */

 if (from.level==LEVEL_PLAN) {
     openpdata(&fire_frompdata);
     putplanet(fire_frompdata,fpl,Stars[from.snum]->planetpos[from.pnum]);
	close_file(fire_frompdata);

 } else if (from.level==LEVEL_SHIP) {
     openshdata(&fire_fromshdata);
     putship(fire_fromshdata, from.shipptr, from.shipno);
	close_file(fire_fromshdata);
 }


 if (to.level==LEVEL_PLAN && !sameplanet) {
     openpdata(&fire_topdata);
     putplanet(fire_topdata,tpl,Stars[to.snum]->planetpos[to.pnum]);
	close_file(fire_topdata);

 } else if (to.level==LEVEL_SHIP) {
     openshdata(&fire_toshdata);
     putship(fire_toshdata,to.shipptr,to.shipno);
	close_file(fire_toshdata);
 }





 if (from.level==LEVEL_PLAN) {
   /* firing from planet -- deduct APs from that star */
 	deductAPs(Playernum,APcount, from.snum, 0);
	free(fpl);
 } else {
		/* from.level==LEVEL_SHIP */
	if (from.shipptr->whatorbits==LEVEL_UNIV)
		deductAPs(Playernum,APcount, 0, 1);
	else {
	 	deductAPs(Playernum,APcount, from.shipptr->storbits, 0);
	}
	free(from.shipptr);
 }

}


