/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 *  load.c -- load/unload stuff
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
#include <signal.h>

int load_shdata,load_pdata,load_sectdata, load_racedata;


load(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
boolean jett=0,sh=0,diff=0;
int first=1,proc,Mod=0,lolim,uplim, shipno,amt;
int test;
int transfercrew;
char commod, buff[128], bufr[128], bufd[128], bufc[128];
shiptype *s,*s2;
planettype *p;
sectortype *sect;

    load_shdata = load_pdata = load_sectdata = NEUTRAL_FD;

	sscanf(args[1]+(args[1][0]=='#'),"%d",&shipno);

    openshdata(&load_shdata);
if (!getship(load_shdata,&s,shipno)) {
    close_file(load_shdata);
	return;
    }
close_file(load_shdata);
if (s->owner!=Playernum || !s->is_alive) {
	DontOwnErr(Playernum,shipno);
	sprintf(buf,"(%d)\n",s->owner);
		notify(Playernum, buf);
	free(s);
	return;
    }
    if (!s->active) {
	sprintf(buf,"%s #%d is irradiated and inactive.\n", Shipnames[s->type],shipno);
		notify(Playernum, buf);
	free(s);
	return;
    }

free(Race);
openracedata(&load_racedata);
getrace(load_racedata, &Race, Playernum);
close_file(load_racedata);

    if (s->whatorbits==LEVEL_UNIV) {
    	if (!enufAP(Playernum,Sdata.AP[Playernum-1], APcount))
		free(s);
    } else 
	if (!enufAP(Playernum,Stars[s->storbits]->AP[Playernum-1], APcount)) {
		free(s);
		return;
	}

   
    proc = 0;

    
    if (s->type == OTYPE_TRANSDEV && s->object.number > 0) {
	openshdata(&load_shdata);
	if (!getship(load_shdata,&s2, s->object.number)) {
		sprintf(buf,"The hopper seems to be blocked.\n");
		notify(Playernum, buf);
		close_file(load_shdata);
		return;
	}
	close_file(load_shdata);
	if (!s2->is_alive) {
		sprintf(buf,"The target device does not exist.\n");
		notify(Playernum, buf);
		return;
	}
	if (s2->type!=OTYPE_TRANSDEV || !s2->on) {
	sprintf(buf,"s2->type = %d\n",s2->type);
		notify(Playernum, buf);
	sprintf(buf,"OTYPE_TRANSDEV = %d\n",OTYPE_TRANSDEV);
		notify(Playernum, buf);

	sprintf(buf,"s2->on = %d\n",s2->on);
		notify(Playernum, buf);
		sprintf(buf,"The target device is not receiving.\n");
		notify(Playernum, buf);
		return;
	}
    } else if (!s->is_docked) {
	if (s->type==OTYPE_TRANSDEV) {
		sprintf(buf,"It does not seem to work in zero-g environments.\n");
		notify(Playernum, buf);
		return;
	}
	sprintf(buf,"%s #%d is not landed.\n",is_object(s)?"object":"ship",shipno);
		notify(Playernum, buf);
		return;
    } else {
	if (s->whatdest==LEVEL_PLAN)
		{
		sprintf(buf,"Ship #%d at %.0f,%.0f\n", shipno, s->xpos, s->ypos);
		notify(Playernum, buf);
  			if(s->storbits != Dir[Playernum-1].snum || s->pnumorbits != Dir[Playernum-1].pnum)
					{
					sprintf(buf,"Wrong scope!\n");
					notify(Playernum, buf);
					return;
					}
		} else {
			openshdata(&load_shdata);
		if (!getship(load_shdata, &s2, s->destshipno) 
			|| !s2->is_alive 
			|| !s->object.number4 &&
			  !(s2->is_docked && s2->whatdest==LEVEL_SHIP 
			  && s2->destshipno==shipno) ) {
				/* the ship it was docked with died or
				   undocked with it or something. */
			s->is_docked = 0;
			s->whatdest = LEVEL_UNIV;
			putship(load_shdata, s, shipno);
			close_file(load_shdata);
			free(s);
			sprintf(buf,"ship #%u is not docked.\n", s->destshipno);
				notify(Playernum, buf);
			return;
		    }
		close(load_shdata);
		sprintf(buf,"Ship #%d docked with %s #%d\n", shipno, 
				Shipnames[s2->type], s->destshipno);
			notify(Playernum, buf);
		sh = 1;
		if (s2->owner!=Playernum) {
			sprintf(buf,"Player %d owns that ship.\n", s2->owner);
				notify(Playernum, buf);
			diff = 1;
		}
	}
    }


 commod = args[2][0];
	if(argn>3)
		    amt = atoi(args[3]);
	else
		    amt = 0;
	
    if (!jett && !sh) {
    	openpdata(&load_pdata);
    	getplanet(load_pdata,&p,Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
	close_file(load_pdata);
    }

       if (!jett && !sh && commod=='c') {
    	opensectdata(&load_sectdata);
    	getsector(load_sectdata, &sect, p->sectormappos 
			+ ( (int)s->ypos*p->Maxx+(int)s->xpos) * sizeof(sectortype) );
	close_file(load_sectdata);
    }

    switch (commod) {

	case 'c': if (jett) {
			uplim = 0;
			lolim = -s->popn;
		  } else
		    if (sh) {
		    	uplim = diff ? 0 : MIN(s2->popn, 
				  Max_crew(s) - s->popn);
			lolim = diff ? 0 : - MIN(s->popn, 
				  Max_crew(s2) - s2->popn);
		    } else {
		    	uplim = MIN(sect->popn, 
				  Max_crew(s) - s->popn);
			lolim = -s->popn;
		    }
		  proc = 1;
		  break;

	case 'd': if (jett) {
			uplim = 0;
			lolim = -s->destruct;
		  } else
		    if (sh) {
		    	uplim = diff ? 0 : MIN(s2->destruct, 
				 Max_destruct(s) - s->destruct);
			lolim = -MIN(s->destruct, 
				 Max_destruct(s2) - s2->destruct);
		    } else {
		    	uplim = MIN(p->info[Playernum-1].destruct,
				 Max_destruct(s) - s->destruct);
			lolim = -s->destruct;
		    }
		  proc = 1;
		  break;

	case 'f': if (jett) {
			uplim = 0;
			lolim = -(int)s->fuel;
		  } else
		    if (sh) {
		    	uplim = diff ? 0.0 : MIN((int)s2->fuel, 
				 Max_fuel(s) - (int)s->fuel);
			lolim = - MIN((int)s->fuel, 
				 Max_fuel(s2) - (int)s2->fuel);
		    } else {
		    	uplim = MIN((int)p->info[Playernum-1].fuel,
				 Max_fuel(s) - (int)s->fuel);
			lolim = -(int)s->fuel;
		    }
		  proc = 1;
		  break;

	case 'r': if (jett) {
			uplim = 0;
			lolim = -s->resource;
		  } else
		    if (sh) {
		    	if (s->type==STYPE_SHUTTLE)
			  uplim = diff ? 0 : s2->resource;
			else
			  uplim = diff ? 0 : MIN(s2->resource, 
				   Max_resource(s) - s->resource);
			if (s2->type==STYPE_SHUTTLE)
			  lolim = -s->resource;
			else
			  lolim = - MIN(s->resource, 
				   Max_resource(s2) - s2->resource);
		    } else {
		    	uplim = MIN(p->info[Playernum-1].resource,
				 Max_resource(s) - s->resource);
			lolim = -s->resource;
		    }
		  proc = 1;
		  break;

	default:
		notify(Playernum, "No such commodity valid.\n");
		return;
      }

if(amt<lolim || amt>uplim) {
	sprintf(buf, "you can only transfer between %d and %d.\n", lolim, uplim);
	notify(Playernum, buf);
	return;
	}

if(amt==0) 
	amt = uplim;

    switch (commod) {

      case 'c': if (!jett) {
			if (sh) {
				s2->popn -= amt;
				s2->mass -= amt*Race->mass;
				transfercrew = 1;
			} else
			  if(sect->owner && sect->owner != Playernum) {
	       	    sprintf(buf,"That sector is already occupied by another player!\n");
				notify(Playernum, buf);
		    transfercrew = 0;
		  	   } else { 
		    transfercrew = 1;
			     if (!sect->popn && amt<0) {
				p->info[Playernum-1].numsectsowned++;
				sect->owner = Playernum;
				sprintf(buf,"sector %.0f,%.0f COLONIZED.\n",s->xpos,s->ypos);
				notify(Playernum, buf);
		  	   }
		  	   sect->popn -= amt;
		  	   p->popn -= amt;
		  	   if (sect->popn==0) {
				p->info[Playernum-1].numsectsowned--;
				sect->owner = 0;
				sprintf(buf,"sector %.0f,%.0f evacuated.\n",s->xpos,s->ypos);
				notify(Playernum, buf);
			      }
			   }
		  }
	  if(transfercrew) {
		  sprintf(buf,"crew complement of ship #%d is now %u.\n", 
			shipno, s->popn+amt);
				notify(Playernum, buf);
		  s->popn += amt;
		  s->mass += amt*Race->mass;
		  Mod = 1;
		}
	  break;

	case 'd': s->destruct += amt;
		  s->mass += amt*MASS_DESTRUCT;
		sprintf(buf, "%d destruct transferred.\n", amt);
		notify(Playernum, buf);
		  if (!Max_crew(s)) {
			sprintf(buf,"\n%s #%d ",Shipnames[s->type], shipno);
				notify(Playernum, buf);
			if (s->destruct) {
			     sprintf(buf,"now boobytrapped.\n");
			} else {
			     sprintf(buf,"no longer boobytrapped.\n");
			 }
				notify(Playernum, buf);
			}

		  if (sh) {
			s2->destruct -= amt;
			s2->mass -= amt*MASS_DESTRUCT;
		  } else if (!jett)
		  	p->info[Playernum-1].destruct -= amt;

		  Mod = 1;
		  break;

	case 'f': s->fuel += amt*1.0;
		  s->mass += amt*MASS_FUEL;
		sprintf(buf, "%d fuel transferred.\n", amt);
		notify(Playernum, buf);

		  if (sh) {
			s2->fuel -= amt*1.0;
			s2->mass -= amt*MASS_FUEL;
		  } else if (!jett)
		  	p->info[Playernum-1].fuel -= amt*1.0;

		  Mod = 1;
		  break;

	case 'r': s->resource += amt;
		  s->mass += amt*MASS_RESOURCE;
		sprintf(buf, "%d resources transferred.\n", amt);
		notify(Playernum, buf);

		  if (sh) {
			s2->resource -= amt;
			s2->mass -= amt*MASS_RESOURCE;
		  } else if (!jett)
		  	p->info[Playernum-1].resource -= amt;

		  Mod = 1;
		  break;

	default:
	   notify(Playernum, "No such commodity.\n");
	   return;
	break;
    }
    openshdata(&load_shdata);
    putship(load_shdata,s,shipno);
    close_file(load_shdata);
    	if (s->type==OTYPE_TRANSDEV && s->object.number > 0) {

	   sprintf(buf,"Zap\07!\n");	 	/* ^G */
				notify(Playernum, buf);

	   	/* send stuff to other ship (could be transport device) */
	   if (s->resource ) {
		s2->mass += s->resource * MASS_RESOURCE;
		s2->resource += s->resource;

		sprintf(buf,"%d resources transferred.\n", s->resource);
				notify(Playernum, buf);
		sprintf(bufr, "%d Resources\n",s->resource);

		s->mass -= s->resource * MASS_RESOURCE;
		s->resource  -= s->resource;
	   } else
		bufr[0] = '\0';
	   if (s->fuel) {
		s2->fuel += s->fuel;
		s2->mass += s->fuel * MASS_FUEL;

		sprintf(buf,"%g fuel transferred.\n", s->fuel);
				notify(Playernum, buf);
		sprintf(buff, "%g Fuel\n",s->fuel);

		s->mass -= s->fuel * MASS_FUEL;
		s->fuel -= s->fuel;
	   } else
		buff[0] = '\0';
	   if (s->destruct) {
		s2->mass += s->destruct * MASS_DESTRUCT;
		s2->destruct += s->destruct;

		sprintf(buf,"%d destruct transferred.\n", s->destruct);
				notify(Playernum, buf);
		sprintf(bufd, "%d Destruct\n",s->destruct);

		s->mass -= s->destruct * MASS_DESTRUCT;
		s->destruct -= s->destruct;
	   } else
		bufd[0] = '\0';
	   if (s->popn) {
		s2->mass += s->popn * Race->mass;
		s2->popn += s->popn;

		sprintf(buf,"%d popn transferred.\n", s->popn);
				notify(Playernum, buf);
		sprintf(bufc, "%d %s\n",s->destruct,Race->Thing?"tons of biomass" : "population");

		s->mass -= s->popn * Race->mass;
		s->popn -= s->popn;
	   } else
		bufc[0] = '\0';

         if (s2->owner!=s->owner) {
	   sprintf(telegram_buf,"BULLETIN!\n\n Audio-vibatory-physio-molecular transport device #");
	   sprintf(buf,"%d just gave your ship #%d the following:\n", shipno, s->object.number);
		str_cat(telegram_buf, buf);
		str_cat(telegram_buf, bufr);
		str_cat(telegram_buf, bufd);
		str_cat(telegram_buf, buff);
		str_cat(telegram_buf, bufc);
		notify(s2->owner, telegram_buf);
         }

	   openshdata(&load_shdata);
	   putship(load_shdata,s,shipno);
	   putship(load_shdata, s2, s->object.number);
	   close_file(load_shdata);

    } else if (sh) {
		/* ship to ship transfer, non-transport device */

	openshdata(&load_shdata);
	putship(load_shdata,s2,s->destshipno);
	close_file(load_shdata);

	buff[0] = bufr[0] = bufd[0] = bufc[0] = '\0';
	switch (commod) {
		case 'r':
			sprintf(buf,"%d resources transferred.\n", amt);
				notify(Playernum, buf);
			sprintf(bufr, "%d Resources\n",amt);
			break;
		case 'f':
			sprintf(buf,"%d fuel transferred.\n", amt);
				notify(Playernum, buf);
			sprintf(buff, "%d Fuel\n",amt);
			break;
		case 'd':
			sprintf(buf,"%d destruct transferred.\n", amt);
				notify(Playernum, buf);
			sprintf(bufd, "%d Destruct\n",amt);
			break;
		case 'c':
			sprintf(buf,"%d popn transferred.\n", amt);
				notify(Playernum, buf);
			sprintf(bufc, "%d %s\n",amt,Race->Thing?"tons of biomass" : "population");
			break;
		default:
			break;
	 }


         if (s2->owner!=s->owner) {
	   sprintf(telegram_buf, "BULLETIN!\n\n Audio-vibatory-physio-molecular transport device #");
	   sprintf(buf,"%d just gave your ship #%d the following:\n", shipno, s->object.number);
		str_cat(telegram_buf, buf);
		str_cat(telegram_buf, bufr);
		str_cat(telegram_buf, bufd);
		str_cat(telegram_buf, buff);
		str_cat(telegram_buf, bufc);
		notify(s2->owner, telegram_buf);
         }
     }

    if (!jett && !sh) {
      if (commod=='c') {
	  opensectdata(&load_sectdata);
	  putsector(load_sectdata,sect,p->sectormappos + ( (int)s->ypos*p->Maxx+(int)s->xpos) * sizeof(sectortype) );
    	close_file(load_sectdata);
	free(sect);
    }
      
      openpdata(&load_pdata);
       putplanet(load_pdata,p,Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
       close_file(load_pdata);
       free(p);
     }

    if (Mod && first) {
         first = 0;
         if (s->whatorbits==LEVEL_UNIV)
		deductAPs(Playernum,APcount, 0, 1);	/* ded from sdata */
         else 
		deductAPs(Playernum,APcount, s->storbits, 0);

    }

}


transfer(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int Mod = 0, transfer_fd, player, give;
planettype *planet;
char commod=0;
racetype *r;

        if (Dir[Playernum-1].level != LEVEL_PLAN) {
	  sprintf(buf,"You need to be in planet scope to do this.\n");
	  notify(Playernum, buf);
	  return;
	      }


	if (!enufAP(Playernum,Stars[Dir[Playernum-1].snum]->AP[Playernum-1], APcount))
	        return;

	GetPlayer(args[1], &player, &r);

if(player < 0 || player > Numraces() ) {
  sprintf(buf,"No such player.\n");
		notify(Playernum, buf);
  return;
	}

    openpdata(&transfer_fd);
    getplanet(transfer_fd, &planet, Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
	close_file(transfer_fd);

	sscanf(args[2],"%c",&commod);
        give = atoi(args[3]);

if(give < 0) {
	notify(Playernum, "You must specify a positive amount.\n");
	return;
	}

switch(commod) {
    case 'r' :
       if(give > planet->info[Playernum-1].resource)
	{
	  sprintf(buf,"You don't have %d on this planet.\n",give);
		notify(Playernum, buf);
	} else {
	  planet->info[Playernum-1].resource -= give;
	  planet->info[player-1].resource += give;
	  sprintf(buf,"%d resources transferred to player #%d\n",give,player);
		notify(Playernum, buf);
	}
      break;
    case 'f' :
      if(give > planet->info[Playernum-1].fuel)
	{
	  sprintf(buf,"You don't have %d fuel on this planet.\n",give);
		notify(Playernum, buf);
	} else {
	  planet->info[Playernum-1].fuel -= give;
	  planet->info[player-1].fuel += give;
	  sprintf(buf,"%d fuel transferred to player #%d\n",give,player);
		notify(Playernum, buf);
	}
      break;
    case 'd' :
      if(give > planet->info[Playernum-1].destruct)
	{
	  sprintf(buf,"You don't have %d destruct on this planet.\n",give);
	  notify(Playernum, buf);
      } else {
	  planet->info[Playernum-1].destruct -= give;
	  planet->info[player-1].destruct += give;
	  sprintf(buf,"%d destruct transferred to player #%d\n",give,player);
		notify(Playernum, buf);
	}
      break;
    default :
      sprintf(buf,"What?\n");
		notify(Playernum, buf);
    }
openpdata(&transfer_fd);
    putplanet(transfer_fd, planet, Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
    close_file(transfer_fd);
Mod = 1;
    if (Mod)
		deductAPs(Playernum,APcount, Dir[Playernum-1].snum, 0);

}

