/* 
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * moveplanet.c -- move the planet in orbit around its star.
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"	/* (needed only for races in doturn.h */
#include "doturn.h"
#include <math.h>


moveplanet(starnum, planet, planetnum)
int starnum;
planettype *planet;
int planetnum;
{
float dist;
float t,xadd,yadd,phase,period;
int sh;
reg int i;
shiptype *ship;

/* return; */

	StarsInhab[starnum] |= Stars[starnum]->inhabited;
	Stars[starnum]->inhabited = 0;

  if (planet->popn)
	Stinfo[starnum][planetnum].inhab = 1;

 if (!StarsInhab[starnum])
	return;		/* no one's explored the star yet */

  dist = hypot((double)planet->ypos, (double)planet->xpos);

phase = atan2((double)planet->ypos, (double)planet->xpos);
period = dist * sqrt((double)dist /
		     (SYSTEMGRAVCONST * Stars[starnum]->gravity));
      /* keppler's law */

  xadd =  dist * cos((double)(-1./period+phase)) - planet->xpos;
  yadd =  dist * sin((double)(-1./period+phase)) - planet->ypos; 
         /* one update time unit - planets orbit counter-clockwise */

/* printf("st %d pl %d xadd %g yadd %g \n", starnum, planetnum, xadd, yadd); 
printf("(%s) \n",Stars[starnum]->name); */

	   /* adjust ships in orbit around the planet */

  sh = planet->ships;

  while (sh && sh<=Num_ships) {	/* just in case... */
	ship=ships[sh];
		/* don't do landed ships */
	   if (ship->is_alive && !(ship->is_docked && ship->whatdest==LEVEL_PLAN)) {
		ship->xpos += xadd;
		ship->ypos += yadd;
	   }
if(sh == ship->nextship)  /* shouldn't happen, but it did */
	sh = 0;
else
	sh = ship->nextship;

  }
/*  printf("**** \n"); */

  planet->xpos += xadd;
  planet->ypos += yadd;

/* well, maybe : */
  if (planet->xpos>SYSTEMSIZE) planet->xpos *= .5;
    else if (planet->xpos< -SYSTEMSIZE) planet->xpos *= .5;
  if (planet->ypos>SYSTEMSIZE) planet->ypos *= .5;
    else if (planet->ypos< -SYSTEMSIZE) planet->ypos *= .5;

}
